'$DYNAMIC
OPEN "D:POISSON.DAT" FOR OUTPUT AS #1
DIM FACTORIAL#(60)
DIM E#(80), B#(80, 80)
REM E is the offered load in Erlangs
REM S is the number of ports, dial in lines or trunks
REM B(i,j) contains grade of service for port or channel i with traffic j
GOSUB 100  'compute factorial 1 TO 60
C = 0
FOR I = 5 TO 400 STEP 5
        C = C + 1
        E# = I / 10
        E#(C) = E#
                K = 0
                FOR S = 0 TO 59   'vary port number
                        K = K + 1
                        SX# = S
                        D# = 0
                        FOR X = 0 TO S
                        D1X# = X
                        D# = D# + (E# ^ D1X#) / (FACTORIAL#(X) * 2.71828 ^ E#)
                        NEXT X
                B#(K, C) = 1# - D#
                B#(X, C) = ABS(B#(K, C))
                NEXT S
  NEXT I
  FOR I = 1 TO 80 STEP 5  ' print 16 pages 5 entries per page
        PRINT #1, "                     POISSON  DISTRIBUTION"
        PRINT #1, "        PROBABILITY ALL PORTS ARE BUSY WHEN CALL ATTEMPTED"
        PRINT #1, "                  WHICH IS THE GRADE OF SERVICE"
        PRINT #1,
        PRINT #1, "PORT #                TRAFFIC IN ERLANGS"
        PRINT #1,
        PRINT #1, USING "      ##.##       ##.##"; E#(I); E#(I + 1);
        PRINT #1, USING "      ##.##"; E#(I + 2);
        PRINT #1, USING "      ##.##       ##.##"; E#(I + 3); E#(I + 4)
        PRINT #1,
        FOR S = 1 TO 60
               
                IF B#(S, I + 4) < .00001# GOTO 50
                PRINT #1, USING "##  #.##### "; S; B#(S, I);
                PRINT #1, USING "    #.#####"; B#(S, I + 1);
                PRINT #1, USING "    #.#####"; B#(S, I + 2);
                PRINT #1, USING "    #.#####"; B#(S, I + 3);
                PRINT #1, USING "    #.#####"; B#(S, I + 4)
        NEXT S
50      REM space to top of page
        FOR LINECOUNT = 1 TO (66 - S)
        PRINT #1,
        NEXT LINECOUNT
NEXT I
CLOSE #1
END
REM subroutine to compute factorials
100 FOR I = 1 TO 60
        p# = 1
                FOR j = I TO 1 STEP -1
                p# = p# * j
                NEXT j
        FACTORIAL#(I) = p#
        NEXT I
        FACTORIAL#(0) = 1#
        RETURN



