REM Traffic Analyzer Program
REM $DYNAMIC
DIM FACTORIAL#(60)
DIM TL#(60), TC#(60)
REM E is the offered load in Erlangs
REM PORT is the number of ports, dial in lines or trunks
REM GOS is the grade of service for port or channel PORT with traffic E
REM TL# is an array that holds traffic lost by port number
REM TC# is an array that holds traffic carried by port number
CLS
PRINT TAB(25); "Traffic Analyzer"
PRINT
PRINT "This program computes the grade of service and the traffic carried"
PRINT "and lost by each port or channel in an n position rotary type group"
PRINT
INPUT "Enter traffic intensity in Erlangs"; E#
1 INPUT "Enter number of ports -maximum 60"; PORT
IF PORT > 60 OR PORT < 1 GOTO 1
GOSUB 100  'compute factorial 1 TO PORT
REM Compute the grade of service
                PORT# = PORT
                N# = (E# ^ PORT#) / FACTORIAL#(PORT)
                        D# = 0
                        FOR S = 0 TO PORT
                        S# = S
                        D# = D# + (E# ^ S#) / FACTORIAL#(S)
                        NEXT S
                GOS# = N# / D#
REM Compute the traffic lost by port            
        FOR S = 1 TO PORT
                S# = S
                LN# = E# * (E# ^ S# / FACTORIAL#(S))
                LD# = 0
                        FOR S1 = 0 TO S
                        S1# = S1
                        LD# = LD# + E# ^ S1# / FACTORIAL#(S1)
                        NEXT S1
                        TL#(S) = LN# / LD#
                NEXT S
REM Compute the traffic carried by port
        FOR I = 1 TO PORT
                IF I = 1 THEN
                        TC#(I) = E# - TL#(1)
                        ELSE
                        TC#(I) = TL#(I - 1) - TL#(I)
                        END IF
        NEXT I
REM Output results
PRINT
PRINT "TOTAL TRAFFIC OFFERED"; E#; "ERLANGS TO"; PORT; "PORTS PROVIDES A";
PRINT USING "##.####"; GOS#;
PRINT " GRADE OF SERVICE"
PRINT
PRINT TAB(25); "TRAFFIC DISTRIBUTION"
PRINT
PRINT "PORT#   TRAFFIC OFFERED   TRAFFIC CARRIED    TRAFFIC LOST"
PRINT
FOR I = 1 TO PORT
        PRINT USING "##"; I;
        PRINT USING "        ###.#####"; E#;
        PRINT USING "        ###.#####"; TC#(I);
        PRINT USING "        ###.#####"; TL#(I)
        E# = E# - TC#(I)
NEXT I
PRINT
PRINT "TRAFFIC LOST BY LAST PORT IS ";
PRINT USING "###.##### "; TL#(PORT);
PRINT "ERLANGS"
PRINT
PRINT "GRADE OF SERVICE IS EQUIVALENT TO 1 IN ";
PRINT USING "#####  "; INT((1 / GOS#) + .5);
PRINT "CALLS RECEIVING A BUSY SIGNAL"
END
REM subroutine to compute factorials
100 FOR I = 1 TO PORT
        p# = 1
                FOR J = I TO 1 STEP -1
                p# = p# * J
                NEXT J
        FACTORIAL#(I) = p#
        NEXT I
        FACTORIAL#(0) = 1
        RETURN



